//+------------------------------------------------------------------+
//|                                             RopebyEricNaiman.mq5 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property description "RopebyEricNaiman by Im_hungry (https://login.mql5.com/en/users/Im_hungry)"
#property description "RopebyEricNaiman - shows the direction of the desire of the market action and the power of this desire."
#property version   "1.00"
#property strict
//---       MovingAverages.mqh
#include <MovingAverages.mqh>
//---
#property indicator_separate_window //     
#property indicator_buffers 12 //  12   
#property indicator_plots   5  //  5  ,    
//---  
#property indicator_label1  "BULL"
#property indicator_type1   DRAW_COLOR_HISTOGRAM
// 0 - clrDarkGreen -   " ",     
// 1 - clrMediumSeaGreen -   " ",     
// 2 - clrLightGreen -   " ",     
// 3 - clrGray -   " "
#property indicator_color1  clrDarkGreen,clrMediumSeaGreen,clrLightGreen,clrGray
#property indicator_style1  STYLE_SOLID
#property indicator_width1  2
//---  
#property indicator_label2  "BEAR"
#property indicator_type2   DRAW_COLOR_HISTOGRAM
// 0 - clrDarkRed -   " ",     
// 1 - clrIndianRed -   " ",     
// 2 - clrLightPink -   " ",     
// 3 - clrGray -   " "
#property indicator_color2  clrDarkRed,clrIndianRed,clrLightPink,clrGray
#property indicator_style2  STYLE_SOLID
#property indicator_width2  2
//---   
#property indicator_label3  "main line"
#property indicator_type3   DRAW_COLOR_LINE
// 0 - clrDarkGreen -   " ",     
// 1 - clrDarkRed -   " ",     
// 2 - clrGray -   "  "
#property indicator_color3  clrDarkGreen,clrDarkRed,clrGray
#property indicator_style3  STYLE_SOLID
#property indicator_width3  2
//---        (main line)  
#property indicator_label4  "ma fast"
#property indicator_type4   DRAW_LINE
#property indicator_color4  clrAqua
#property indicator_style4  STYLE_SOLID
#property indicator_width4  1
//---        (main line)  
#property indicator_label5  "ma slow"
#property indicator_type5   DRAW_LINE
#property indicator_color5  clrYellow
#property indicator_style5  STYLE_SOLID
#property indicator_width5  1
//--- input parameters
input string section_1="___ main settings";
//---      
input bool draw_histogram=true;
//---     
input bool draw_line=true;
//---  
input int _period=76;
//--- ,   
input ENUM_APPLIED_PRICE _price=PRICE_CLOSE;
//---          
input int max_bars=0;
//---           .         line_deviation
input double line_deviation=3.0;
//---
input string section_2="___ MA fast";
//---    
input bool draw_MA_fast=false;
//---      
input int period_MA_fast=25;
//---     
input ENUM_MA_METHOD method_MA_fast=MODE_SMA;
//---
input string section_3="___ MA slow";
//---    
input bool draw_MA_slow=false;
//---      
input int period_MA_slow=143;
//---     
input ENUM_MA_METHOD method_MA_slow=MODE_SMA;
//---- buffers
datetime _tm_prev;
double Buffer_main_bull[];
double Buffer_color_bull[];
double Buffer_main_bear[];
double Buffer_color_bear[];
double Buffer_calc[];
double Buffer_calcLINE[];
double Buffer_calc_bull[];
double Buffer_calc_bear[];
double Buffer_mainline[];
double Buffer_MAfast[];
double Buffer_MAslow[];
double sum_bull;
double sum_bear;
double Buffer_mainline_color[];
int total_bull;
int total_bear;
int bars_calc;
int _digits;
int prev_rates_total;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---       
   Print(__FUNCTION__+"\\ Initialization | _period: ",_period);
//---      
   _digits=(int)SymbolInfoInteger(Symbol(),SYMBOL_DIGITS);
//---    
   IndicatorSetInteger(INDICATOR_DIGITS,_digits);
//---   ,     
   IndicatorSetString(INDICATOR_SHORTNAME,"RopebyEricNaiman");
//--- INDICATOR_DATA -    
//--- INDICATOR_COLOR_INDEX -   
//--- INDICATOR_CALCULATIONS -         
   SetIndexBuffer(0,Buffer_main_bull,INDICATOR_DATA); //    
   SetIndexBuffer(1,Buffer_color_bull,INDICATOR_COLOR_INDEX);  //    
   SetIndexBuffer(2,Buffer_main_bear,INDICATOR_DATA); //    
   SetIndexBuffer(3,Buffer_color_bear,INDICATOR_COLOR_INDEX);  //    
   SetIndexBuffer(4,Buffer_mainline,INDICATOR_DATA); //     
   SetIndexBuffer(5,Buffer_mainline_color,INDICATOR_COLOR_INDEX); //      
   SetIndexBuffer(6,Buffer_MAfast,INDICATOR_DATA); //    
   SetIndexBuffer(7,Buffer_MAslow,INDICATOR_DATA); //    
   SetIndexBuffer(8,Buffer_calc,INDICATOR_CALCULATIONS); //    
   SetIndexBuffer(9,Buffer_calc_bull,INDICATOR_CALCULATIONS); //    
   SetIndexBuffer(10,Buffer_calc_bear,INDICATOR_CALCULATIONS); //     
   SetIndexBuffer(11,Buffer_calcLINE,INDICATOR_CALCULATIONS); //     
//---       prev_rates_total (rates_total    // rates_total =   price[])
   _tm_prev=0;
   prev_rates_total=0;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,//   price[]
                const int prev_calculated,//     
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   ArraySetAsSeries(time,true);
//---      ,    0        
   ArraySetAsSeries(open,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
   ArraySetAsSeries(close,true);
   ArraySetAsSeries(Buffer_main_bull,true);
   ArraySetAsSeries(Buffer_color_bull,true);
   ArraySetAsSeries(Buffer_main_bear,true);
   ArraySetAsSeries(Buffer_color_bear,true);
   ArraySetAsSeries(Buffer_mainline,true);
   ArraySetAsSeries(Buffer_mainline_color,true);
   ArraySetAsSeries(Buffer_MAfast,true);
   ArraySetAsSeries(Buffer_MAslow,true);
   ArraySetAsSeries(Buffer_calc,true);
   ArraySetAsSeries(Buffer_calc_bull,true);
   ArraySetAsSeries(Buffer_calc_bear,true);
   ArraySetAsSeries(Buffer_calcLINE,true);
//--- 
   int copy=0;
   bars_calc=0;
//---   
//---  prev_calculated = 0        , =0              ,  
   if(prev_calculated==0) _tm_prev=0;
//---     ,        
   if(prev_rates_total>rates_total) _tm_prev=0;
   if(_tm_prev<time[0]) //     
     {
      if(_tm_prev>0) //       
        {
         copy=TakeShift_byTime(Symbol(),PERIOD_CURRENT,_tm_prev); //          
         if(copy<=0) //    ,       
           {
            return 0;
           }
         bars_calc=copy+1; //           
         //---     , ..     
         Buffer_main_bull[0]=0.0;
         Buffer_color_bull[0]=5; //      5   ,    
         Buffer_main_bear[0]=0.0;
         Buffer_color_bear[0]=5; //      5   ,    
         Buffer_mainline[0]=0.0;
         Buffer_mainline_color[0]=5; //      5   ,    
         Buffer_MAfast[0]=0.0;
         Buffer_MAslow[0]=0.0;
         Buffer_calc[0]=0.0;
         Buffer_calc_bull[0]=0.0;
         Buffer_calc_bear[0]=0.0;
         Buffer_calcLINE[0]=0.0;
        }
      else //          
        {
         bars_calc=Bars(Symbol(),PERIOD_CURRENT)-1; //           -1
         //---            
         for(int i=0; i<Bars(Symbol(),PERIOD_CURRENT) && !IsStopped(); i++)
           {
            Buffer_main_bull[i]=0.0;
            Buffer_main_bear[i]=0.0;
            Buffer_mainline[i]=0.0;
            Buffer_MAfast[i]=0.0;
            Buffer_MAslow[i]=0.0;
            Buffer_calc[i]=0.0;
            Buffer_calc_bull[i]=0.0;
            Buffer_calc_bear[i]=0.0;
            Buffer_calcLINE[i]=0.0;
           }
        }
      //---        ,   
      if(bars_calc<0) return 0;
      //---        max_bars
      if(bars_calc>max_bars && max_bars!=0) bars_calc=max_bars;
      for(int i=1; i<bars_calc && !IsStopped(); i++)
        {
         //---          _price
         switch(_price)
           {
            case PRICE_CLOSE:
               Buffer_calc[i]=close[i]-close[i+1];
               break;
            case PRICE_OPEN:
               Buffer_calc[i]=open[i]-open[i+1];
               break;
            case PRICE_HIGH:
               Buffer_calc[i]=high[i]-high[i+1];
               break;
            case PRICE_LOW:
               Buffer_calc[i]=low[i]-low[i+1];
               break;
            case PRICE_MEDIAN:
               Buffer_calc[i]=((high[i]+low[i])/2)-((high[i+1]+low[i+1])/2);
               break;
            case PRICE_TYPICAL:
               Buffer_calc[i]=((high[i]+low[i]+close[i])/3)-((high[i+1]+low[i+1]+close[i+1])/3);
               break;
            case PRICE_WEIGHTED:
               Buffer_calc[i]=((high[i]+low[i]+close[i]+close[i])/4)-((high[i+1]+low[i+1]+close[i+1]+close[i+1])/4);
               break;
            default: return 0;
           }
        }
      //---       ,         IsStopped=true    (       )
      for(int i=1; i<=bars_calc && !IsStopped(); i++)
        {
         //---   
         sum_bull=0.0; //     ( )    
         total_bull=0; //        
         sum_bear=0.0; //     ( )    
         total_bear=0; //        
         //---
         Buffer_main_bull[i]=0.0;
         Buffer_color_bull[i]=5;
         Buffer_main_bear[i]=0.0;
         Buffer_color_bear[i]=5;
         Buffer_mainline[i]=0.0;
         Buffer_mainline_color[0]=5;
         //---
         Buffer_calc_bull[i]=0.0;
         Buffer_calc_bear[i]=0.0;
         Buffer_calcLINE[i]=0.0;
         //---    ,             
         if(i>=(rates_total-_period)) continue;
         //---      (_period)     
         for(int i2=i; i2<i+_period; i2++)
           {
            //---   
            if(Buffer_calc[i2]>0)
              {
               sum_bull+=Buffer_calc[i2]; //     ("      ")
               total_bull++; //     ("      ")
              }
            //---   
            if(Buffer_calc[i2]<0)
              {
               sum_bear+=Buffer_calc[i2]; //     ("      ")
               total_bear++; //     ("      ")
              }
           }
         //---   ,         
         if(total_bull>0) Buffer_calc_bull[i]=sum_bull/total_bull;
         //---   
         if(total_bear>0) Buffer_calc_bear[i]=sum_bear/total_bear;
         //---         
         if(draw_histogram)
           {
            //---   ,         
            if(total_bull>0) Buffer_main_bull[i]=sum_bull/total_bull;
            //---   ,         
            if(total_bear>0) Buffer_main_bear[i]=sum_bear/total_bear;
            //--- 0   clrDarkGreen -   " ",     
            //---   -       
            //---   >      >      >  
            //---  -  
            //---  -     
            //---  -          /
            if(total_bull>total_bear && MathAbs(sum_bull)>MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])>MathAbs(Buffer_main_bear[i])) Buffer_color_bull[i]=0;
            else
              {
               //--- 1   clrMediumSeaGreen -   " ",     
               //---   -       ,   
               if((total_bull>total_bear && MathAbs(sum_bull)>MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])<MathAbs(Buffer_main_bear[i])) || 
                  (total_bull>total_bear && MathAbs(sum_bull)<MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])>MathAbs(Buffer_main_bear[i])) || 
                  (total_bull<total_bear && MathAbs(sum_bull)>MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])>MathAbs(Buffer_main_bear[i]))) Buffer_color_bull[i]=1;
               else
                 {
                  //--- 2   clrLightGreen -   " ",     
                  //---   -       ,   
                  if((total_bull>total_bear && MathAbs(sum_bull)<MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])<MathAbs(Buffer_main_bear[i])) || 
                     (total_bull<total_bear && MathAbs(sum_bull)>MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])<MathAbs(Buffer_main_bear[i])) || 
                     (total_bull<total_bear && MathAbs(sum_bull)<MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])>MathAbs(Buffer_main_bear[i]))) Buffer_color_bull[i]=2;
                  else
                    {
                     //--- 3   clrGray -   " "
                     //---   -    
                     Buffer_color_bull[i]=3;
                    }
                 }
              }
            //--- 0   clrDarkRed -   " ",     
            //---   -       
            if(total_bull<total_bear && MathAbs(sum_bull)<MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])<MathAbs(Buffer_main_bear[i])) Buffer_color_bear[i]=0;
            else
              {
               //--- 1   clrIndianRed -   " ",     
               //---   -       ,   
               if((total_bull<total_bear && MathAbs(sum_bull)<MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])>MathAbs(Buffer_main_bear[i])) || 
                  (total_bull<total_bear && MathAbs(sum_bull)>MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])<MathAbs(Buffer_main_bear[i])) || 
                  (total_bull>total_bear && MathAbs(sum_bull)<MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])<MathAbs(Buffer_main_bear[i]))) Buffer_color_bear[i]=1;
               else
                 {
                  //--- 2   clrLightPink -   " ",     
                  //---   -       ,   
                  if((total_bull<total_bear && MathAbs(sum_bull)>MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])>MathAbs(Buffer_main_bear[i])) || 
                     (total_bull>total_bear && MathAbs(sum_bull)<MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])>MathAbs(Buffer_main_bear[i])) || 
                     (total_bull>total_bear && MathAbs(sum_bull)>MathAbs(sum_bear) && MathAbs(Buffer_main_bull[i])<MathAbs(Buffer_main_bear[i]))) Buffer_color_bear[i]=2;
                  else
                    {
                     //--- 3   clrGray -   " "
                     //---   -    
                     Buffer_color_bear[i]=3;
                    }
                 }
              }
           }
         //---    ,     
         Buffer_calcLINE[i]=(Buffer_calc_bull[i]+Buffer_calc_bear[i])*line_deviation;
         //---         
         // 0 - clrDarkGreen -   " ",     
         // 1 - clrDarkRed -   " ",     
         // 2 - clrGray -   "  "
         if(draw_line)
           {
            //---    ,     
            Buffer_mainline[i]=(Buffer_calc_bull[i]+Buffer_calc_bear[i])*line_deviation;
            //---     (2 - clrGray)
            Buffer_mainline_color[i]=2;
            //---     (0 - clrDarkGreen)       (bull>bear)
            if(total_bull>total_bear && MathAbs(sum_bull)>MathAbs(sum_bear) && MathAbs(Buffer_calc_bull[i])>MathAbs(Buffer_calc_bear[i])) Buffer_mainline_color[i]=0;
            //---     (1 - clrDarkRed)       (bear>bull)
            if(total_bull<total_bear && MathAbs(sum_bull)<MathAbs(sum_bear) && MathAbs(Buffer_calc_bull[i])<MathAbs(Buffer_calc_bear[i])) Buffer_mainline_color[i]=1;
           }
        }
      //---    
      if(draw_MA_fast || draw_MA_slow)
        {
         //---          MovingAverages.mqh (   ,     -   )
         ArraySetAsSeries(Buffer_calcLINE,false);
         ArraySetAsSeries(Buffer_MAfast,false);
         ArraySetAsSeries(Buffer_MAslow,false);
         //---    .  =   (rates_total) -        _tm_prev (bars_calc)
         for(int i=rates_total-bars_calc; i<rates_total && !IsStopped(); i++)
           {
            //---       max_bars,     max_bars       (rates_total)   (max_bars)
            if(max_bars>0?(i<(rates_total-max_bars)):false)
              {
               //---    i     ,     
               i=rates_total-max_bars;
               continue;
              }
            //---        
            Buffer_MAfast[i]=0.0;
            Buffer_MAslow[i]=0.0;
            //---        method_MA_fast
            if(draw_MA_fast)
              {
               switch(method_MA_fast)
                 {
                  case MODE_SMA: //  
                     Buffer_MAfast[i]=SimpleMA(i,period_MA_fast,Buffer_calcLINE); //    SimpleMA  i   Include\\MovingAverages.mqh    Buffer_calcLINE   period_MA_fast
                     break;
                  case MODE_EMA: //  
                     Buffer_MAfast[i]=ExponentialMA(i,period_MA_fast,Buffer_MAfast[i-1],Buffer_calcLINE);
                     break;
                  case MODE_SMMA: //  
                     Buffer_MAfast[i]=SmoothedMA(i+period_MA_fast,period_MA_fast,Buffer_MAfast[i-1],Buffer_calcLINE);
                     break;
                  case MODE_LWMA: // - 
                     Buffer_MAfast[i]=LinearWeightedMA(i+period_MA_fast,period_MA_fast,Buffer_calcLINE);
                     break;
                  default: return 0;
                 }
              }
            //---        method_MA_slow
            if(draw_MA_slow)
              {
               switch(method_MA_slow)
                 {
                  case MODE_SMA: //  
                     Buffer_MAslow[i]=SimpleMA(i,period_MA_slow,Buffer_calcLINE);
                     break;
                  case MODE_EMA: //  
                     Buffer_MAslow[i]=ExponentialMA(i,period_MA_slow,Buffer_MAslow[i-1],Buffer_calcLINE);
                     break;
                  case MODE_SMMA: //  
                     Buffer_MAslow[i]=SmoothedMA(i,period_MA_slow,Buffer_MAslow[i-1],Buffer_calcLINE);
                     break;
                  case MODE_LWMA: // - 
                     Buffer_MAslow[i]=LinearWeightedMA(i,period_MA_slow,Buffer_calcLINE);
                     break;
                  default: return 0;
                 }
              }
           }
         //---       
         ArraySetAsSeries(Buffer_calcLINE,true);
         ArraySetAsSeries(Buffer_MAfast,true);
         ArraySetAsSeries(Buffer_MAslow,true);
         //---      , ..  
         Buffer_MAfast[0]=EMPTY_VALUE;
         Buffer_MAslow[0]=EMPTY_VALUE;
         Buffer_calcLINE[0]=EMPTY_VALUE;
        }
      //---     
      _tm_prev=time[0];
     }
//--- return value of prev_calculated for next call
   prev_rates_total=rates_total;
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| TakeShift_byTime                                                 |
//+------------------------------------------------------------------+
int TakeShift_byTime(string symbol_forShift,
                     ENUM_TIMEFRAMES tf_forShift,
                     datetime time_forShift)
  {
   if((int)time_forShift==0) return -1;
   datetime array[];
//---        time_forShift
   int copy=CopyTime(symbol_forShift,tf_forShift,TimeCurrent(),time_forShift,array);
   return copy;
  }
//+------------------------------------------------------------------+
